<?php

namespace itguild\forms\inputs;

use itguild\forms\traits\CreateParams;
use itguild\forms\inputs\BaseInput;

class Checkbox extends BaseInput
{
    use CreateParams;

    private string $name;
    private string $value;
    private array $paramsArray;


    /**
     * @param string $name
     * @param string $value
     * @param array $paramsArray
     */
    public function __construct(string $name, string $value, array $paramsArray = [])
    {
        $this->name = $name;
        $this->value = $value;
        $this->paramsArray = $paramsArray;
    }

    /**
     * @return $this
     */
    public function create(): self
    {
        $paramsString = $this->createParams($this->paramsArray);
        $this->html = "<input name='$this->name' type='checkbox' value='$this->value' $paramsString >";
        return $this;
    }

    /**
     * @param string $name
     * @param string $value
     * @param array $paramsArray
     * @return void
     */
    public static function build(string $name, string $value, array $paramsArray): void
    {
        $checkbox = new self($name, $value, $paramsArray);
        $checkbox->create()->render();

    }

    /**
     * @param string $title
     * @return $this
     */
    public function setLabel(string $title): self
    {
        $this->html = "<label>$title $this->html</label>";
        return $this;
    }
}