<?php

namespace itguild\forms\inputs;
use itguild\forms\traits\CreateParams;
use itguild\forms\inputs\BaseInput;
class Radio extends BaseInput
{
    use CreateParams;

    private $name;
    private $paramsArray;

    public function __construct(string $name, array $paramsArray = [])
    {
        $this->name = $name;
        $this->paramsArray = $paramsArray;
    }

    /**
     * @return $this
     */
    public function create(): self
    {
        $paramsString = $this->createParams($this->paramsArray);
        $this->html = "<input name='$this->name' type='radio' $paramsString>";

        return $this;
    }

    /**
     * @param string $name
     * @param array $paramsArray
     * @return void
     */
    public static function build(string $name, array $paramsArray = []): void
    {
        $label = new self($name, $paramsArray);
        $label->create()->render();
    }

    /**
     * @param string $title
     * @return $this
     */
    public function setLabel(string $title): self
    {
        $this->html = "<label>$title $this->html</label>";
        return $this;
    }
}