<?php

namespace itguild\forms\inputs;

use itguild\forms\inputs\BaseInput;
use itguild\forms\traits\CreateParams;

class TextInput extends BaseInput
{

    use CreateParams;
    private string $name;

    private array $paramsArray;


    /**
     * @param string $name
     * @param array $paramsArray
     */
    public function __construct(string $name, array $paramsArray = [])
    {
        $this->name = $name;
        $this->paramsArray = $paramsArray;
    }

    /**
     * @return self
     */
    public function create(): self
    {
        $paramsString = $this->createParams($this->paramsArray);
        $this->html = "<input name='$this->name' $paramsString >";

        return $this;
    }

    /**
     * @param string $name
     * @param array $paramsArray
     * @return void
     */
    public static function build(string $name, array $paramsArray = []): void
    {
        $input = new self($name, $paramsArray);
        $input->create()->render();

    }

    /**
     * @param string $title
     * @return $this
     */
    public function setLabel(string $title): self
    {
        $this->html = "<label>$title $this->html</label>";
        return $this;
    }


}